Update devel/ruby-gems to 2.7.1

diff --git a/devel/ruby-gems/Makefile b/devel/ruby-gems/Makefile
index 4776e9bb7de0..79afe5204a13 100644
--- a/devel/ruby-gems/Makefile
+++ b/devel/ruby-gems/Makefile
@@ -6,7 +6,7 @@
 # - www/rubygem-gitlab-grack/files/patch-gemspec
 
 PORTNAME=	gems
-PORTVERSION=	2.6.14
+PORTVERSION=	2.7.1
 CATEGORIES=	devel ruby
 MASTER_SITES=	http://production.cf.rubygems.org/rubygems/
 PKGNAMEPREFIX=	${RUBY_PKGNAMEPREFIX}
diff --git a/devel/ruby-gems/distinfo b/devel/ruby-gems/distinfo
index a23fc3fee8cc..e177a25f547c 100644
--- a/devel/ruby-gems/distinfo
+++ b/devel/ruby-gems/distinfo
@@ -1,3 +1,3 @@
-TIMESTAMP = 1507626380
-SHA256 (ruby/rubygems-2.6.14.tgz) = 406a45d258707f52241843e9c7902bbdcf00e7edc3e88cdb79c46659b47851ec
-SIZE (ruby/rubygems-2.6.14.tgz) = 769418
+TIMESTAMP = 1509849348
+SHA256 (ruby/rubygems-2.7.1.tgz) = b5edd299eb12e503f2f4a47c1c5766ce8cca6711a894eb22f5142f5e9ce0048a
+SIZE (ruby/rubygems-2.7.1.tgz) = 826455
diff --git a/devel/ruby-gems/files/patch-bundler_bundler.gemspec b/devel/ruby-gems/files/patch-bundler_bundler.gemspec
new file mode 100644
index 000000000000..9f62a56123f2
--- /dev/null
+++ b/devel/ruby-gems/files/patch-bundler_bundler.gemspec
@@ -0,0 +1,11 @@
+--- bundler/bundler.gemspec.orig	2017-11-05 02:50:15 UTC
++++ bundler/bundler.gemspec
+@@ -42,7 +42,7 @@ Gem::Specification.new do |s|
+   s.add_development_dependency "ronn",       "~> 0.7.3"
+   s.add_development_dependency "rspec",      "~> 3.6"
+ 
+-  s.files = `git ls-files -z`.split("\x0").select {|f| f.match(%r{^(lib|exe)/}) }
++  s.files = Dir["bundler/{lib,exe}/**/*"].select { |e| File.file?(e) }.sort
+   # we don't check in man pages, but we need to ship them because
+   # we use them to generate the long-form help for each command.
+   s.files += Dir.glob("man/**/*")
diff --git a/devel/ruby-gems/files/patch-lib_rubygems_commands_setup__command.rb b/devel/ruby-gems/files/patch-lib_rubygems_commands_setup__command.rb
new file mode 100644
index 000000000000..558077090b7f
--- /dev/null
+++ b/devel/ruby-gems/files/patch-lib_rubygems_commands_setup__command.rb
@@ -0,0 +1,48 @@
+--- lib/rubygems/commands/setup_command.rb.orig	2017-11-05 02:58:30 UTC
++++ lib/rubygems/commands/setup_command.rb
+@@ -16,7 +16,7 @@ class Gem::Commands::SetupCommand < Gem:
+           :format_executable => true, :document => %w[ri],
+           :site_or_vendor => 'sitelibdir',
+           :destdir => '', :prefix => '', :previous_version => '',
+-          :regenerate_binstubs => true
++          :regenerate_binstubs => false
+ 
+     add_option '--previous-version=VERSION',
+                'Previous version of RubyGems',
+@@ -82,11 +82,7 @@ class Gem::Commands::SetupCommand < Gem:
+ 
+     add_option '--[no-]regenerate-binstubs',
+                'Regenerate gem binstubs' do |value, options|
+-      if value then
+-        options[:regenerate_binstubs] = true
+-      else
+-        options.delete(:regenerate_binstubs)
+-      end
++      options[:regenerate_binstubs] = value
+    end
+ 
+     @verbose = nil
+@@ -156,7 +152,7 @@ By default, this RubyGems will install g
+ 
+     say "RubyGems #{Gem::VERSION} installed"
+ 
+-    regenerate_binstubs
++    regenerate_binstubs if options[:regenerate_binstubs]
+ 
+     uninstall_old_gemcutter
+ 
+@@ -366,9 +362,11 @@ By default, this RubyGems will install g
+ 
+     bundler_spec = Gem::Specification.load(default_spec_path)
+ 
+-    Dir.entries(bundler_spec.gems_dir).
+-      select {|default_gem| default_gem.start_with?("bundler-") }.
+-      each {|default_gem| rm_r File.join(bundler_spec.gems_dir, default_gem) }
++    if Dir.exist? bundler_spec.gems_dir
++      Dir.entries(bundler_spec.gems_dir).
++        select {|default_gem| default_gem.start_with?("bundler-") }.
++        each {|default_gem| rm_r File.join(bundler_spec.gems_dir, default_gem) }
++    end
+ 
+     mkdir_p bundler_spec.bin_dir
+     bundler_spec.executables.each {|e| cp File.join("bundler", bundler_spec.bindir, e), File.join(bundler_spec.bin_dir, e) }
diff --git a/devel/ruby-gems/pkg-plist b/devel/ruby-gems/pkg-plist
index 6fed5207da18..8f756bf88a4c 100644
--- a/devel/ruby-gems/pkg-plist
+++ b/devel/ruby-gems/pkg-plist
@@ -1,8 +1,198 @@
+bin/bundle%%RUBY_VER_SHORT%%
 bin/gem
 bin/gem%%RUBY_VER_SHORT%%
+%%RUBY_SITELIBDIR%%/bundler.rb
+%%RUBY_SITELIBDIR%%/bundler/build_metadata.rb
+%%RUBY_SITELIBDIR%%/bundler/capistrano.rb
+%%RUBY_SITELIBDIR%%/bundler/cli.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/add.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/binstubs.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/cache.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/check.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/clean.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/common.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/config.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/console.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/doctor.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/exec.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/gem.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/info.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/init.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/inject.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/install.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/issue.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/list.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/lock.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/open.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/outdated.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/package.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/platform.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/plugin.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/pristine.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/show.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/update.rb
+%%RUBY_SITELIBDIR%%/bundler/cli/viz.rb
+%%RUBY_SITELIBDIR%%/bundler/compact_index_client.rb
+%%RUBY_SITELIBDIR%%/bundler/compact_index_client/cache.rb
+%%RUBY_SITELIBDIR%%/bundler/compact_index_client/updater.rb
+%%RUBY_SITELIBDIR%%/bundler/compatibility_guard.rb
+%%RUBY_SITELIBDIR%%/bundler/constants.rb
+%%RUBY_SITELIBDIR%%/bundler/current_ruby.rb
+%%RUBY_SITELIBDIR%%/bundler/definition.rb
+%%RUBY_SITELIBDIR%%/bundler/dep_proxy.rb
+%%RUBY_SITELIBDIR%%/bundler/dependency.rb
+%%RUBY_SITELIBDIR%%/bundler/deployment.rb
+%%RUBY_SITELIBDIR%%/bundler/deprecate.rb
+%%RUBY_SITELIBDIR%%/bundler/dsl.rb
+%%RUBY_SITELIBDIR%%/bundler/endpoint_specification.rb
+%%RUBY_SITELIBDIR%%/bundler/env.rb
+%%RUBY_SITELIBDIR%%/bundler/environment_preserver.rb
+%%RUBY_SITELIBDIR%%/bundler/errors.rb
+%%RUBY_SITELIBDIR%%/bundler/feature_flag.rb
+%%RUBY_SITELIBDIR%%/bundler/fetcher.rb
+%%RUBY_SITELIBDIR%%/bundler/fetcher/base.rb
+%%RUBY_SITELIBDIR%%/bundler/fetcher/compact_index.rb
+%%RUBY_SITELIBDIR%%/bundler/fetcher/dependency.rb
+%%RUBY_SITELIBDIR%%/bundler/fetcher/downloader.rb
+%%RUBY_SITELIBDIR%%/bundler/fetcher/index.rb
+%%RUBY_SITELIBDIR%%/bundler/friendly_errors.rb
+%%RUBY_SITELIBDIR%%/bundler/gem_helper.rb
+%%RUBY_SITELIBDIR%%/bundler/gem_helpers.rb
+%%RUBY_SITELIBDIR%%/bundler/gem_remote_fetcher.rb
+%%RUBY_SITELIBDIR%%/bundler/gem_tasks.rb
+%%RUBY_SITELIBDIR%%/bundler/gem_version_promoter.rb
+%%RUBY_SITELIBDIR%%/bundler/gemdeps.rb
+%%RUBY_SITELIBDIR%%/bundler/graph.rb
+%%RUBY_SITELIBDIR%%/bundler/index.rb
+%%RUBY_SITELIBDIR%%/bundler/injector.rb
+%%RUBY_SITELIBDIR%%/bundler/inline.rb
+%%RUBY_SITELIBDIR%%/bundler/installer.rb
+%%RUBY_SITELIBDIR%%/bundler/installer/gem_installer.rb
+%%RUBY_SITELIBDIR%%/bundler/installer/parallel_installer.rb
+%%RUBY_SITELIBDIR%%/bundler/installer/standalone.rb
+%%RUBY_SITELIBDIR%%/bundler/lazy_specification.rb
+%%RUBY_SITELIBDIR%%/bundler/lockfile_generator.rb
+%%RUBY_SITELIBDIR%%/bundler/lockfile_parser.rb
+%%RUBY_SITELIBDIR%%/bundler/match_platform.rb
+%%RUBY_SITELIBDIR%%/bundler/mirror.rb
+%%RUBY_SITELIBDIR%%/bundler/plugin.rb
+%%RUBY_SITELIBDIR%%/bundler/plugin/api.rb
+%%RUBY_SITELIBDIR%%/bundler/plugin/api/source.rb
+%%RUBY_SITELIBDIR%%/bundler/plugin/dsl.rb
+%%RUBY_SITELIBDIR%%/bundler/plugin/index.rb
+%%RUBY_SITELIBDIR%%/bundler/plugin/installer.rb
+%%RUBY_SITELIBDIR%%/bundler/plugin/installer/git.rb
+%%RUBY_SITELIBDIR%%/bundler/plugin/installer/rubygems.rb
+%%RUBY_SITELIBDIR%%/bundler/plugin/source_list.rb
+%%RUBY_SITELIBDIR%%/bundler/process_lock.rb
+%%RUBY_SITELIBDIR%%/bundler/psyched_yaml.rb
+%%RUBY_SITELIBDIR%%/bundler/remote_specification.rb
+%%RUBY_SITELIBDIR%%/bundler/resolver.rb
+%%RUBY_SITELIBDIR%%/bundler/resolver/spec_group.rb
+%%RUBY_SITELIBDIR%%/bundler/retry.rb
+%%RUBY_SITELIBDIR%%/bundler/ruby_dsl.rb
+%%RUBY_SITELIBDIR%%/bundler/ruby_version.rb
+%%RUBY_SITELIBDIR%%/bundler/rubygems_ext.rb
+%%RUBY_SITELIBDIR%%/bundler/rubygems_gem_installer.rb
+%%RUBY_SITELIBDIR%%/bundler/rubygems_integration.rb
+%%RUBY_SITELIBDIR%%/bundler/runtime.rb
+%%RUBY_SITELIBDIR%%/bundler/settings.rb
+%%RUBY_SITELIBDIR%%/bundler/settings/validator.rb
+%%RUBY_SITELIBDIR%%/bundler/setup.rb
+%%RUBY_SITELIBDIR%%/bundler/shared_helpers.rb
+%%RUBY_SITELIBDIR%%/bundler/similarity_detector.rb
+%%RUBY_SITELIBDIR%%/bundler/source.rb
+%%RUBY_SITELIBDIR%%/bundler/source/gemspec.rb
+%%RUBY_SITELIBDIR%%/bundler/source/git.rb
+%%RUBY_SITELIBDIR%%/bundler/source/git/git_proxy.rb
+%%RUBY_SITELIBDIR%%/bundler/source/metadata.rb
+%%RUBY_SITELIBDIR%%/bundler/source/path.rb
+%%RUBY_SITELIBDIR%%/bundler/source/path/installer.rb
+%%RUBY_SITELIBDIR%%/bundler/source/rubygems.rb
+%%RUBY_SITELIBDIR%%/bundler/source/rubygems/remote.rb
+%%RUBY_SITELIBDIR%%/bundler/source_list.rb
+%%RUBY_SITELIBDIR%%/bundler/spec_set.rb
+%%RUBY_SITELIBDIR%%/bundler/ssl_certs/certificate_manager.rb
+%%RUBY_SITELIBDIR%%/bundler/ssl_certs/index.rubygems.org/GlobalSignRootCA.pem
+%%RUBY_SITELIBDIR%%/bundler/ssl_certs/rubygems.global.ssl.fastly.net/DigiCertHighAssuranceEVRootCA.pem
+%%RUBY_SITELIBDIR%%/bundler/ssl_certs/rubygems.org/AddTrustExternalCARoot.pem
+%%RUBY_SITELIBDIR%%/bundler/stub_specification.rb
+%%RUBY_SITELIBDIR%%/bundler/templates/gems.rb
+%%RUBY_SITELIBDIR%%/bundler/ui.rb
+%%RUBY_SITELIBDIR%%/bundler/ui/rg_proxy.rb
+%%RUBY_SITELIBDIR%%/bundler/ui/shell.rb
+%%RUBY_SITELIBDIR%%/bundler/ui/silent.rb
+%%RUBY_SITELIBDIR%%/bundler/uri_credentials_filter.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/fileutils/lib/fileutils.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/compatibility.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/delegates/resolution_state.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/delegates/specification_provider.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/dependency_graph.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/dependency_graph/action.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/dependency_graph/add_edge_no_circular.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/dependency_graph/add_vertex.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/dependency_graph/delete_edge.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/dependency_graph/detach_vertex_named.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/dependency_graph/log.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/dependency_graph/set_payload.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/dependency_graph/tag.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/dependency_graph/vertex.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/errors.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/gem_metadata.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/modules/specification_provider.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/modules/ui.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/resolution.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/resolver.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/molinillo/lib/molinillo/state.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/net-http-persistent/lib/net/http/faster.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/net-http-persistent/lib/net/http/persistent.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/net-http-persistent/lib/net/http/persistent/ssl_reuse.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/actions.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/actions/create_file.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/actions/create_link.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/actions/directory.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/actions/empty_directory.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/actions/file_manipulation.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/actions/inject_into_file.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/base.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/command.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/core_ext/hash_with_indifferent_access.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/core_ext/io_binary_read.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/core_ext/ordered_hash.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/error.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/group.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/invocation.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/line_editor.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/line_editor/basic.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/line_editor/readline.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/parser.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/parser/argument.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/parser/arguments.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/parser/option.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/parser/options.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/rake_compat.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/runner.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/shell.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/shell/basic.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/shell/color.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/shell/html.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/util.rb
+%%RUBY_SITELIBDIR%%/bundler/vendor/thor/lib/thor/version.rb
+%%RUBY_SITELIBDIR%%/bundler/vendored_fileutils.rb
+%%RUBY_SITELIBDIR%%/bundler/vendored_molinillo.rb
+%%RUBY_SITELIBDIR%%/bundler/vendored_persistent.rb
+%%RUBY_SITELIBDIR%%/bundler/vendored_thor.rb
+%%RUBY_SITELIBDIR%%/bundler/version.rb
+%%RUBY_SITELIBDIR%%/bundler/version_ranges.rb
+%%RUBY_SITELIBDIR%%/bundler/vlad.rb
+%%RUBY_SITELIBDIR%%/bundler/worker.rb
+%%RUBY_SITELIBDIR%%/bundler/yaml_serializer.rb
 %%RUBY_SITELIBDIR%%/rubygems.rb
 %%RUBY_SITELIBDIR%%/rubygems/available_set.rb
 %%RUBY_SITELIBDIR%%/rubygems/basic_specification.rb
+%%RUBY_SITELIBDIR%%/rubygems/bundler_version_finder.rb
 %%RUBY_SITELIBDIR%%/rubygems/command.rb
 %%RUBY_SITELIBDIR%%/rubygems/command_manager.rb
 %%RUBY_SITELIBDIR%%/rubygems/commands/build_command.rb
@@ -29,6 +219,8 @@ bin/gem%%RUBY_VER_SHORT%%
 %%RUBY_SITELIBDIR%%/rubygems/commands/search_command.rb
 %%RUBY_SITELIBDIR%%/rubygems/commands/server_command.rb
 %%RUBY_SITELIBDIR%%/rubygems/commands/setup_command.rb
+%%RUBY_SITELIBDIR%%/rubygems/commands/signin_command.rb
+%%RUBY_SITELIBDIR%%/rubygems/commands/signout_command.rb
 %%RUBY_SITELIBDIR%%/rubygems/commands/sources_command.rb
 %%RUBY_SITELIBDIR%%/rubygems/commands/specification_command.rb
 %%RUBY_SITELIBDIR%%/rubygems/commands/stale_command.rb
@@ -148,6 +340,7 @@ bin/gem%%RUBY_VER_SHORT%%
 %%RUBY_SITELIBDIR%%/rubygems/security/policy.rb
 %%RUBY_SITELIBDIR%%/rubygems/security/signer.rb
 %%RUBY_SITELIBDIR%%/rubygems/security/trust_dir.rb
+%%RUBY_SITELIBDIR%%/rubygems/security_option.rb
 %%RUBY_SITELIBDIR%%/rubygems/server.rb
 %%RUBY_SITELIBDIR%%/rubygems/source.rb
 %%RUBY_SITELIBDIR%%/rubygems/source/git.rb