Index: www/apache24/Makefile
===================================================================
--- www/apache24/Makefile	(revision 453750)
+++ www/apache24/Makefile	(working copy)
@@ -42,12 +42,7 @@
 USERS=		www
 GROUPS=		www
 
-# for slave ports
-.if !defined(MASTERDIR)
 APACHEDIR=	${.CURDIR}
-.else
-APACHEDIR=	${MASTERDIR}
-.endif
 
 WITH_HTTP_PORT?=	80
 WITH_SSL_PORT?=		443
@@ -56,58 +51,55 @@
 EXTRA_PATCHES+=	${FILESDIR}/extra-patch-server_buildmark.c
 .endif
 
-.include "${APACHEDIR}/Makefile.options"
-.include "${APACHEDIR}/Makefile.options.desc"
+.include "Makefile.options"
+.include "Makefile.options.desc"
+OPTIONS_SUB=	yes
 
 # IMPLIES
+AUTH_BASIC_IMPLIES=		AUTHN_CORE
+AUTH_DIGEST_IMPLIES=		AUTHN_CORE AUTHZ_CORE
 AUTHN_DBD_IMPLIES=		DBD
 HEARTBEAT_IMPLIES=		WATCHDOG STATUS
 HEARTMONITOR_IMPLIES=		WATCHDOG STATUS
 LBMETHOD_HEARTBEAT_IMPLIES=	WATCHDOG STATUS HEARTMONITOR
 PROXY_HCHECK_IMPLIES=		WATCHDOG
+PROXY_HTTP2_IMPLIES=		PROXY_BALANCER
 
-# MPM
-MPM_PREFORK_CONFIGURE_ON=	--with-mpm=prefork
-MPM_WORKER_CONFIGURE_ON=	--with-mpm=worker
-MPM_EVENT_CONFIGURE_ON=		--with-mpm=event
-
-AUTHNZ_LDAP_CONFIGURE_ON=	--enable-authnz-ldap
-
+AUTHNZ_LDAP_USE=		openldap=yes
+BROTLI_CONFIGURE_WITH=		brotli=${LOCALBASE}
+BROTLI_LIB_DEPENDS=		libbrotlicommon.so:archivers/brotli
+HTTP2_CONFIGURE_WITH=		nghttp2=${LOCALBASE}
+HTTP2_LIB_DEPENDS=		libnghttp2.so:www/libnghttp2
 # http://httpd.apache.org/docs/2.4/bind.html
 IPV4_MAPPED_CONFIGURE_ENABLE=	v4-mapped
-
-LDAP_CONFIGURE_ON=		--enable-ldap=shared
-
-BROTLI_CONFIGURE_ON=		--with-brotli=${LOCALBASE}
-BROTLI_LIB_DEPENDS=		libbrotlicommon.so:archivers/brotli
-HTTP2_CONFIGURE_ON=		--with-nghttp2=${LOCALBASE}
-HTTP2_LIB_DEPENDS=		libnghttp2.so:www/libnghttp2
+LDAP_USE=			openldap=yes
 LUAJIT_LIB_DEPENDS=		libluajit-5.1.so:lang/luajit
-LUA_CONFIGURE_WITH=		lua
+LUA_CONFIGURE_ENV=		LUA_CFLAGS="-I${LUA_INCDIR}" \
+				LUA_LIBS="-L${LUA_LIBDIR} -llua-${LUA_VER}"
+LUA_CONFIGURE_WITH=		lua=${PREFIX}
 LUA_USES=			lua
-PROXY_HTTP2_CONFIGURE_ON=	--with-nghttp2=${LOCALBASE}
+MPM_PREFORK_CONFIGURE_ON=	--with-mpm=prefork
+MPM_WORKER_CONFIGURE_ON=	--with-mpm=worker
+MPM_EVENT_CONFIGURE_ON=		--with-mpm=event
+MPM_SHARED_CONFIGURE_ON=	--enable-mpms-shared=all
+PROXY_HTML_USE=			gnnome=libxml2
+PROXY_HTML_WITH=		libxml2=${LOCALBASE}/include/libxml2
+PROXY_HTTP2_CONFIGURE_WITH=	nghttp2=${LOCALBASE}
 PROXY_HTTP2_LIB_DEPENDS=	libnghttp2.so:www/libnghttp2
-SOCACHE_DC_CONFIGURE_ON=	--with-distcache=${LOCALBASE}
+SOCACHE_DC_CONFIGURE_WITH=	distcache=${LOCALBASE}
 SOCACHE_DC_LIB_DEPENDS=		libdistcache.so:security/distcache
-
-# Note:
-# OpenSSL version (base/ports) depends how devel/apr1 was build
-#  apu-1-config --(includes|ldflags) and apr_rules.mk
-SSL_CFLAGS=			-I${OPENSSLINC}
-SSL_CONFIGURE_ON=		--with-ssl=${OPENSSLBASE}
-SSL_LDFLAGS=			-L${OPENSSLLIB}
+SSL_CONFIGURE_WITH=		ssl=${OPENSSLBASE}
 SSL_USES=			ssl
+XML2ENC_USE=			gnome=libxml2
+XML2ENC_WITH=			libxml2=${LOCALBASE}/include/libxml2
+.for mod in ${EXAMPLE_DISABLED_MODULES}
+${mod}_VARS=                    with-devmods=yes
+.endfor
 
-.include <bsd.port.options.mk>
 ETC_SUBDIRS=		Includes envvars.d extra modules.d
 
 APR_CONFIG?=		${LOCALBASE}/bin/apr-1-config
 APU_CONFIG?=		${LOCALBASE}/bin/apu-1-config
-
-# APU modules used by AUTHN_DBD DBD
-APU_DBD_MYSQL?=		${LOCALBASE}/lib/apr-util-1/apr_dbd_mysql.so
-APU_DBD_PGSQL?=		${LOCALBASE}/lib/apr-util-1/apr_dbd_pgsql.so
-APU_DBD_SQLITE3?=	${LOCALBASE}/lib/apr-util-1/apr_dbd_sqlite3.so
 # APU module used by AUTHNZ_LDAP LDAP
 APU_LDAP?=		${LOCALBASE}/lib/apr-util-1/apr_ldap.so
 # APU module used by SESSION_CRYPTO
@@ -134,21 +126,8 @@
 		INSTALL_MAN="${INSTALL_MAN}" \
 		DATADIR=${DATADIR}
 
-#=====================================================
-# CONFIGURE_ARGS will be handled in Makefile.modules,
-# here we do only OPTIONS fixups
-
-.if ${PORT_OPTIONS:MLUA}
-CONFIGURE_ENV+=	LUA_CFLAGS="-I${LUA_INCDIR}" \
-		LUA_LIBS="-L${LUA_LIBDIR} -llua-${LUA_VER}"
-.endif
-
-.if ${PORT_OPTIONS:MPROXY_HTML} || ${PORT_OPTIONS:MXML2ENC}
-USE_GNOME=	libxml2
-.endif
-
 .include <bsd.port.pre.mk>
-.include "${APACHEDIR}/Makefile.modules"
+.include "Makefile.modules"
 
 .if ${OPSYS} == FreeBSD && ${OSVERSION} < 1100085 &&\
 	${PORT_OPTIONS:MHTTP2} && ${OPENSSLBASE} == /usr
Index: www/apache24/Makefile.modules
===================================================================
--- www/apache24/Makefile.modules	(revision 453750)
+++ www/apache24/Makefile.modules	(working copy)
@@ -28,23 +28,7 @@
 .endif	# exists APU_CONFIG
 
 # =============================================
-.if ${PORT_OPTIONS:MMPM_SHARED}
-SUB_LIST+=		MPM_FALLBACK_CHECK=""
-PLIST_SUB+=		MPM_SHARED=""
-CONFIGURE_ARGS+=	--enable-mpms-shared=all
-.else
-SUB_LIST+=		MPM_FALLBACK_CHECK="\#"
-PLIST_SUB+=		MPM_SHARED="@comment "
-.endif
-
-# =============================================
 # build develop/example modules only with additional confirmation
-.for DEVMOD in ${EXAMPLE_MODULES}
-.  if ${PORT_OPTIONS:M${DEVMOD}}
-WITH_DEVMODS=	yes
-.  endif
-.endfor
-
 .if defined(WITH_DEVMODS) && !defined(IAMADEVELOPER )
 IGNORE=		to build the develop/example modules specify -DIAMADEVELOPER on the command line.\
 		Do not use the this modules in production environment
@@ -68,26 +52,4 @@
 CONFIGURE_ARGS+=	--enable-exception-hook
 .endif
 
-.if ${PORT_OPTIONS:MAUTH_BASIC} || ${PORT_OPTIONS:MAUTH_DIGEST}
-.  if !${APACHE_MODULES:MAUTHN*}
-IGNORE=	AUTH_BASIC and AUTH_DIGEST need at least one AUTHN provider
-.  endif
-.endif
-
-.if ${PORT_OPTIONS:MAUTH_BASIC}
-.  if !${APACHE_MODULES:MAUTHZ*}
-IGNORE=	AUTH_BASIC need at least one AUTHZ provider
-.  endif
-.endif
-
-.if ${PORT_OPTIONS:MXML2ENC} || ${PORT_OPTIONS:MPROXY_HTML}
-CONFIGURE_ARGS+=	--with-libxml2=${LOCALBASE}/include/libxml2
-.else
-CONFIGURE_ARGS+=	--without-libxml2
-.endif
-
-.if ${PORT_OPTIONS:MPROXY_HTTP2} && !${PORT_OPTIONS:MPROXY_BALANCER}
-IGNORE=	PROXY_HTTP2 requires PROXY_BALANCER
-.endif
-
 .endif	# _PREMKINCLUDED
Index: www/apache24/Makefile.options
===================================================================
--- www/apache24/Makefile.options	(revision 453750)
+++ www/apache24/Makefile.options	(working copy)
@@ -8,93 +8,73 @@
 # Required modules without OPTION:
 #   UNIXD LOG_CONFIG
 
+AUTH_ENABLED_MODULES= \
+	ACCESS_COMPAT ALLOWMETHODS AUTH_BASIC AUTH_DIGEST AUTH_FORM AUTHN_ANON \
+	AUTHN_CORE AUTHN_DBD AUTHN_DBM AUTHN_FILE AUTHN_SOCACHE AUTHZ_CORE AUTHZ_DBD \
+	AUTHZ_DBM AUTHNZ_FCGI AUTHZ_GROUPFILE AUTHZ_HOST AUTHZ_OWNER AUTHZ_USER
+AUTH_DISABLED_MODULES= AUTHNZ_LDAP
 
-# mod_proxy_html and xml2enc depending on libxml2
-PROXY_ENABLED_MODULES= \
-	PROXY_AJP PROXY_BALANCER PROXY_CONNECT PROXY_EXPRESS PROXY_FCGI PROXY_HTTP2 \
-	PROXY_FDPASS PROXY_FTP PROXY_HCHECK PROXY_HTML PROXY_HTTP PROXY_SCGI PROXY_WSTUNNEL
+CACHE_ENABLED_MODULES= \
+	CACHE CACHE_DISK CACHE_SOCACHE FILE_CACHE SOCACHE_DBM SOCACHE_MEMCACHE \
+	SOCACHE_SHMCB
+CACHE_DISABLED_MODULES=	SOCACHE_DC
 
-PROXY_DISABLED_MODULES=
-
-# SESSION_CRYPTO need APR build with crypto (EVP support in APR)
-SESSION_ENABLED_MODULES= \
-	SESSION_COOKIE SESSION_CRYPTO SESSION_DBD
-
-SESSION_DISABLED_MODULES=
-
-EXAMPLE_MODULES= \
+EXAMPLE_DISABLED_MODULES= \
 	BUCKETEER CASE_FILTER CASE_FILTER_IN ECHO EXAMPLE_HOOKS EXAMPLE_IPC \
 	OPTIONAL_FN_EXPORT OPTIONAL_FN_IMPORT OPTIONAL_HOOK_EXPORT \
 	OPTIONAL_HOOK_IMPORT
 
-MOST_ENABLED_MODULES= \
-	ACCESS_COMPAT ACTIONS ALIAS ALLOWMETHODS ASIS \
-	AUTHN_ANON AUTHN_CORE AUTHN_DBD AUTHN_DBM AUTHN_FILE AUTHN_SOCACHE \
-	AUTHZ_CORE AUTHZ_DBD AUTHZ_DBM AUTHNZ_FCGI AUTHZ_GROUPFILE AUTHZ_HOST \
-	AUTHZ_OWNER AUTHZ_USER \
-	AUTH_BASIC AUTH_DIGEST AUTH_FORM AUTOINDEX \
-	BUFFER \
-	CACHE CACHE_DISK CACHE_SOCACHE CERN_META CGI CGID \
-	CHARSET_LITE \
-	DATA DAV DAV_FS DAV_LOCK DBD DEFLATE DIALUP DIR DUMPIO \
-	ENV EXPIRES EXT_FILTER \
-	FILE_CACHE FILTER \
-	HEADERS HEARTBEAT HEARTMONITOR HTTP2 \
-	IMAGEMAP INCLUDE INFO \
-	LBMETHOD_BYBUSYNESS LBMETHOD_BYREQUESTS LBMETHOD_BYTRAFFIC \
-	LBMETHOD_HEARTBEAT LOGIO LOG_DEBUG LOG_FORENSIC \
-	MACRO MIME MIME_MAGIC \
-	NEGOTIATION \
-	RATELIMIT REFLECTOR REMOTEIP REQTIMEOUT REQUEST REWRITE \
-	SED SETENVIF \
-	SLOTMEM_PLAIN SLOTMEM_SHM SOCACHE_DBM SOCACHE_MEMCACHE SOCACHE_SHMCB \
-	SPELING SSL STATUS SUBSTITUTE \
-	UNIQUE_ID USERDIR USERTRACK \
-	VERSION VHOST_ALIAS \
-	WATCHDOG XML2ENC
+FILTERS_ENABLED_MODULES = \
+        BUFFER CHARSET_LITE DATA DEFLATE EXT_FILTER FILTER INCLUDE RATELIMIT \
+	REQTIMEOUT REQUEST SED SUBSTITUTE XML2ENC
+FILTERS_DISABLED_MODULES= BROTLI
 
-MOST_DISABLED_MODULES:= \
-	AUTHNZ_LDAP BROTLI IDENT LDAP LUA SOCACHE_DC SUEXEC
+GENERATORS_ENABLED_MODULES= \
+	AUTOINDEX CGI CGID INFO STATUS
 
-#     enable/disable additional PROXY/SESSION modules
-META_MODULES=	PROXY SESSION
+LOG_ENABLED_MODULES= \
+	DUMPIO LOGIO LOG_CONFIG LOG_DEBUG LOG_FORENSIC USERTRACK
+LOG_DISABLED_MODULES= IDENT
 
-ALL_MODULES_CATEGORIES=	\
-	MOST_ENABLED MOST_DISABLED MULTI \
-	PROXY_ENABLED PROXY_DISABLED \
-	SESSION_ENABLED SESSION_DISABLED \
-	META EXAMPLE
+MAPPERS_ENABLED_MODULES = \
+        ACTIONS ALIAS DIR NEGOTIATION REWRITE SPELING USERDIR VHOST_ALIAS
 
-ADDITIONAL_OPT=	LUAJIT IPV4_MAPPED
+METADATA_ENABLED_MODULES= \
+        CERN_META ENV EXPIRES HEADERS MIME MIME_MAGIC REMOTEIP SETENVIF \
+	UNIQUE_ID VERSION
 
-# ===================================================================================
-#NO_OPTIONS_SORT=	yes
+PROXYGR_ENABLED_MODULES= \
+	HEARTBEAT HEARTMONITOR PROXY PROXY_AJP PROXY_BALANCER PROXY_CONNECT \
+	PROXY_EXPRESS PROXY_FCGI PROXY_FDPASS PROXY_FTP PROXY_HCHECK PROXY_HTML \
+	PROXY_HTTP PROXY_HTTP2 PROXY_SCGI PROXY_WSTUNNEL LBMETHOD_BYBUSYNESS \
+	LBMETHOD_BYREQUESTS LBMETHOD_BYTRAFFIC LBMETHOD_HEARTBEAT
 
-OPTIONS_MULTI:=		${META_MODULES}
-OPTIONS_MULTI_PROXY:=	${PROXY_ENABLED_MODULES} ${PROXY_DISABLED_MODULES}
-OPTIONS_MULTI_SESSION:=	${SESSION_ENABLED_MODULES} ${SESSION_DISABLED_MODULES}
+SECURITY_ENABLED_MODULES=	SSL
+SECURITY_DISABLED_MODULES=	SUEXEC
 
-OPTIONS_GROUP=		EXAMPLE
-OPTIONS_GROUP_EXAMPLE:=	${EXAMPLE_MODULES}
+SESSIONGR_ENABLED_MODULES= \
+	SESSION SESSION_COOKIE SESSION_CRYPTO SESSION_DBD
 
-OPTIONS_RADIO=			SHARED_MPM
-OPTIONS_RADIO_SHARED_MPM=	MPM_SHARED
+NOCAT_ENABLED_MODULES= \
+        ASIS DAV DAV_FS DAV_LOCK DATA DBD DIALUP HTTP2 IMAGEMAP MACRO REFLECTOR \
+        SLOTMEM_PLAIN SLOTMEM_SHM WATCHDOG
 
+NOCAT_DISABLED_MODULES= \
+        LDAP LUA
+
+# Generate OPTIONS_ variables
+OPTIONS_GROUP=	AUTH CACHE EXAMPLE FILTERS GENERATORS LOG MAPPERS METADATA \
+	PROXYGR SECURITY SESSIONGR NOCAT
+.for _grp in ${OPTIONS_GROUP}
+ALL_MODULES_CATEGORIES+= ${_grp}_ENABLED ${_grp}_DISABLED
+OPTIONS_GROUP_${_grp}=	${${_grp}_ENABLED_MODULES} ${${_grp}_DISABLED_MODULES}
+OPTIONS_DEFAULT+=	${${_grp}_ENABLED_MODULES}
+.endfor
+
+
+OPTIONS_DEFINE=	IPV4_MAPPED LUAJIT MPM_SHARED
+
 OPTIONS_SINGLE=			DEFAULT_MPM
 OPTIONS_SINGLE_DEFAULT_MPM=	MPM_PREFORK MPM_WORKER MPM_EVENT
 
-# ===================================================================================
-
-OPTIONS_DEFINE:=		\
-	${MOST_ENABLED_MODULES}	\
-	${MOST_DISABLED_MODULES}\
-	${ADDITIONAL_OPT}	\
-	${OPTIONS_MULTI}
-
-OPTIONS_DEFAULT:=		\
-	${MOST_ENABLED_MODULES}	\
-	${OPTIONS_MULTI}	\
-	${SESSION_ENABLED_MODULES} \
-	${PROXY_ENABLED_MODULES} \
-	MPM_SHARED \
-	MPM_PREFORK
+OPTIONS_DEFAULT+=	MPM_SHARED MPM_PREFORK
Index: www/apache24/Makefile.options.desc
===================================================================
--- www/apache24/Makefile.options.desc	(revision 453750)
+++ www/apache24/Makefile.options.desc	(working copy)
@@ -2,12 +2,18 @@
 
 # vim: syntax=make ts=8 noet
 # =====================================
-# OPTIONS HEADING
-PROXY_DESC=			Build enabled PROXY modules
-SESSION_DESC=			Build enabled SESSION modules
-DEFAULT_MPM_DESC=		The default MPM module
-SHARED_MPM_DESC=		Build all MPMs as shared Module
+AUTH_DESC=			Authentication and Authorization modules
+CACHEGR_DESC=			Cache modules (imply mod_cache)
 EXAMPLE_DESC=			Example and devel modules (do not use in prod)
+FILTERS_DESC=			Filter modules
+GENERATORS_DESC=		Modules generating content
+LOG_DESC=			Logging and debugging modules
+METADATA_DESC=			Modules operating on metadata
+MAPPERS_DESC=			Mapping modules (transform)
+NOCAT_DESC=			Uncatgegorized modules
+PROXYGR_DESC=			Proxy modules (imply mod_proxy) and options
+SECURITY_DESC=			Security related modules
+SESSIONGR_DESC=			Session modules (imply mod_session)
 
 # =====================================
 # MPMs
Index: www/apache24/pkg-plist
===================================================================
--- www/apache24/pkg-plist	(revision 453750)
+++ www/apache24/pkg-plist	(working copy)
@@ -85,133 +85,133 @@
 include/apache24/util_varbuf.h
 include/apache24/util_xml.h
 libexec/apache24/httpd.exp
-%%MOD_ACCESS_COMPAT%%libexec/apache24/mod_access_compat.so
-%%MOD_ACTIONS%%libexec/apache24/mod_actions.so
-%%MOD_ALIAS%%libexec/apache24/mod_alias.so
-%%MOD_ALLOWMETHODS%%libexec/apache24/mod_allowmethods.so
-%%MOD_ASIS%%libexec/apache24/mod_asis.so
-%%MOD_AUTH_BASIC%%libexec/apache24/mod_auth_basic.so
-%%MOD_AUTH_DIGEST%%libexec/apache24/mod_auth_digest.so
-%%MOD_AUTH_FORM%%libexec/apache24/mod_auth_form.so
-%%MOD_AUTHN_ANON%%libexec/apache24/mod_authn_anon.so
-%%MOD_AUTHN_CORE%%libexec/apache24/mod_authn_core.so
-%%MOD_AUTHN_DBD%%libexec/apache24/mod_authn_dbd.so
-%%MOD_AUTHN_DBM%%libexec/apache24/mod_authn_dbm.so
-%%MOD_AUTHN_FILE%%libexec/apache24/mod_authn_file.so
-%%MOD_AUTHN_SOCACHE%%libexec/apache24/mod_authn_socache.so
-%%MOD_AUTHNZ_FCGI%%libexec/apache24/mod_authnz_fcgi.so
-%%MOD_AUTHNZ_LDAP%%libexec/apache24/mod_authnz_ldap.so
-%%MOD_AUTHZ_CORE%%libexec/apache24/mod_authz_core.so
-%%MOD_AUTHZ_DBD%%libexec/apache24/mod_authz_dbd.so
-%%MOD_AUTHZ_DBM%%libexec/apache24/mod_authz_dbm.so
-%%MOD_AUTHZ_GROUPFILE%%libexec/apache24/mod_authz_groupfile.so
-%%MOD_AUTHZ_HOST%%libexec/apache24/mod_authz_host.so
-%%MOD_AUTHZ_OWNER%%libexec/apache24/mod_authz_owner.so
-%%MOD_AUTHZ_USER%%libexec/apache24/mod_authz_user.so
-%%MOD_AUTOINDEX%%libexec/apache24/mod_autoindex.so
-%%MOD_BROTLI%%libexec/apache24/mod_brotli.so
-%%MOD_BUCKETEER%%libexec/apache24/mod_bucketeer.so
-%%MOD_BUFFER%%libexec/apache24/mod_buffer.so
-%%MOD_CACHE%%libexec/apache24/mod_cache.so
-%%MOD_CACHE_DISK%%libexec/apache24/mod_cache_disk.so
-%%MOD_CACHE_SOCACHE%%libexec/apache24/mod_cache_socache.so
-%%MOD_CASE_FILTER%%libexec/apache24/mod_case_filter.so
-%%MOD_CASE_FILTER_IN%%libexec/apache24/mod_case_filter_in.so
-%%MOD_CERN_META%%libexec/apache24/mod_cern_meta.so
-%%MOD_CGI%%libexec/apache24/mod_cgi.so
-%%MOD_CGID%%libexec/apache24/mod_cgid.so
-%%MOD_CHARSET_LITE%%libexec/apache24/mod_charset_lite.so
-%%MOD_DATA%%libexec/apache24/mod_data.so
-%%MOD_DAV%%libexec/apache24/mod_dav.so
-%%MOD_DAV_FS%%libexec/apache24/mod_dav_fs.so
-%%MOD_DAV_LOCK%%libexec/apache24/mod_dav_lock.so
-%%MOD_DBD%%libexec/apache24/mod_dbd.so
-%%MOD_DEFLATE%%libexec/apache24/mod_deflate.so
-%%MOD_DIALUP%%libexec/apache24/mod_dialup.so
-%%MOD_DIR%%libexec/apache24/mod_dir.so
-%%MOD_DUMPIO%%libexec/apache24/mod_dumpio.so
-%%MOD_ECHO%%libexec/apache24/mod_echo.so
-%%MOD_ENV%%libexec/apache24/mod_env.so
-%%MOD_EXAMPLE_HOOKS%%libexec/apache24/mod_example_hooks.so
-%%MOD_EXAMPLE_IPC%%libexec/apache24/mod_example_ipc.so
-%%MOD_EXPIRES%%libexec/apache24/mod_expires.so
-%%MOD_EXT_FILTER%%libexec/apache24/mod_ext_filter.so
-%%MOD_FILE_CACHE%%libexec/apache24/mod_file_cache.so
-%%MOD_FILTER%%libexec/apache24/mod_filter.so
-%%MOD_HEADERS%%libexec/apache24/mod_headers.so
-%%MOD_HEARTBEAT%%libexec/apache24/mod_heartbeat.so
-%%MOD_HEARTMONITOR%%libexec/apache24/mod_heartmonitor.so
-%%MOD_HTTP2%%libexec/apache24/mod_http2.so
-%%MOD_IDENT%%libexec/apache24/mod_ident.so
-%%MOD_IMAGEMAP%%libexec/apache24/mod_imagemap.so
-%%MOD_INCLUDE%%libexec/apache24/mod_include.so
-%%MOD_INFO%%libexec/apache24/mod_info.so
-%%MOD_LBMETHOD_BYBUSYNESS%%libexec/apache24/mod_lbmethod_bybusyness.so
-%%MOD_LBMETHOD_BYREQUESTS%%libexec/apache24/mod_lbmethod_byrequests.so
-%%MOD_LBMETHOD_BYTRAFFIC%%libexec/apache24/mod_lbmethod_bytraffic.so
-%%MOD_LBMETHOD_HEARTBEAT%%libexec/apache24/mod_lbmethod_heartbeat.so
-%%MOD_LDAP%%libexec/apache24/mod_ldap.so
+%%ACCESS_COMPAT%%libexec/apache24/mod_access_compat.so
+%%ACTIONS%%libexec/apache24/mod_actions.so
+%%ALIAS%%libexec/apache24/mod_alias.so
+%%ALLOWMETHODS%%libexec/apache24/mod_allowmethods.so
+%%ASIS%%libexec/apache24/mod_asis.so
+%%AUTH_BASIC%%libexec/apache24/mod_auth_basic.so
+%%AUTH_DIGEST%%libexec/apache24/mod_auth_digest.so
+%%AUTH_FORM%%libexec/apache24/mod_auth_form.so
+%%AUTHN_ANON%%libexec/apache24/mod_authn_anon.so
+%%AUTHN_CORE%%libexec/apache24/mod_authn_core.so
+%%AUTHN_DBD%%libexec/apache24/mod_authn_dbd.so
+%%AUTHN_DBM%%libexec/apache24/mod_authn_dbm.so
+%%AUTHN_FILE%%libexec/apache24/mod_authn_file.so
+%%AUTHN_SOCACHE%%libexec/apache24/mod_authn_socache.so
+%%AUTHNZ_FCGI%%libexec/apache24/mod_authnz_fcgi.so
+%%AUTHNZ_LDAP%%libexec/apache24/mod_authnz_ldap.so
+%%AUTHZ_CORE%%libexec/apache24/mod_authz_core.so
+%%AUTHZ_DBD%%libexec/apache24/mod_authz_dbd.so
+%%AUTHZ_DBM%%libexec/apache24/mod_authz_dbm.so
+%%AUTHZ_GROUPFILE%%libexec/apache24/mod_authz_groupfile.so
+%%AUTHZ_HOST%%libexec/apache24/mod_authz_host.so
+%%AUTHZ_OWNER%%libexec/apache24/mod_authz_owner.so
+%%AUTHZ_USER%%libexec/apache24/mod_authz_user.so
+%%AUTOINDEX%%libexec/apache24/mod_autoindex.so
+%%BROTLI%%libexec/apache24/mod_brotli.so
+%%BUCKETEER%%libexec/apache24/mod_bucketeer.so
+%%BUFFER%%libexec/apache24/mod_buffer.so
+%%CACHE%%libexec/apache24/mod_cache.so
+%%CACHE_DISK%%libexec/apache24/mod_cache_disk.so
+%%CACHE_SOCACHE%%libexec/apache24/mod_cache_socache.so
+%%CASE_FILTER%%libexec/apache24/mod_case_filter.so
+%%CASE_FILTER_IN%%libexec/apache24/mod_case_filter_in.so
+%%CERN_META%%libexec/apache24/mod_cern_meta.so
+%%CGI%%libexec/apache24/mod_cgi.so
+%%CGID%%libexec/apache24/mod_cgid.so
+%%CHARSET_LITE%%libexec/apache24/mod_charset_lite.so
+%%DATA%%libexec/apache24/mod_data.so
+%%DAV%%libexec/apache24/mod_dav.so
+%%DAV_FS%%libexec/apache24/mod_dav_fs.so
+%%DAV_LOCK%%libexec/apache24/mod_dav_lock.so
+%%DBD%%libexec/apache24/mod_dbd.so
+%%DEFLATE%%libexec/apache24/mod_deflate.so
+%%DIALUP%%libexec/apache24/mod_dialup.so
+%%DIR%%libexec/apache24/mod_dir.so
+%%DUMPIO%%libexec/apache24/mod_dumpio.so
+%%ECHO%%libexec/apache24/mod_echo.so
+%%ENV%%libexec/apache24/mod_env.so
+%%EXAMPLE_HOOKS%%libexec/apache24/mod_example_hooks.so
+%%EXAMPLE_IPC%%libexec/apache24/mod_example_ipc.so
+%%EXPIRES%%libexec/apache24/mod_expires.so
+%%EXT_FILTER%%libexec/apache24/mod_ext_filter.so
+%%FILE_CACHE%%libexec/apache24/mod_file_cache.so
+%%FILTER%%libexec/apache24/mod_filter.so
+%%HEADERS%%libexec/apache24/mod_headers.so
+%%HEARTBEAT%%libexec/apache24/mod_heartbeat.so
+%%HEARTMONITOR%%libexec/apache24/mod_heartmonitor.so
+%%HTTP2%%libexec/apache24/mod_http2.so
+%%IDENT%%libexec/apache24/mod_ident.so
+%%IMAGEMAP%%libexec/apache24/mod_imagemap.so
+%%INCLUDE%%libexec/apache24/mod_include.so
+%%INFO%%libexec/apache24/mod_info.so
+%%LBMETHOD_BYBUSYNESS%%libexec/apache24/mod_lbmethod_bybusyness.so
+%%LBMETHOD_BYREQUESTS%%libexec/apache24/mod_lbmethod_byrequests.so
+%%LBMETHOD_BYTRAFFIC%%libexec/apache24/mod_lbmethod_bytraffic.so
+%%LBMETHOD_HEARTBEAT%%libexec/apache24/mod_lbmethod_heartbeat.so
+%%LDAP%%libexec/apache24/mod_ldap.so
 libexec/apache24/mod_log_config.so
-%%MOD_LOG_DEBUG%%libexec/apache24/mod_log_debug.so
-%%MOD_LOG_FORENSIC%%libexec/apache24/mod_log_forensic.so
-%%MOD_LOGIO%%libexec/apache24/mod_logio.so
-%%MOD_LUA%%libexec/apache24/mod_lua.so
-%%MOD_MACRO%%libexec/apache24/mod_macro.so
-%%MOD_MIME%%libexec/apache24/mod_mime.so
-%%MOD_MIME_MAGIC%%libexec/apache24/mod_mime_magic.so
+%%LOG_DEBUG%%libexec/apache24/mod_log_debug.so
+%%LOG_FORENSIC%%libexec/apache24/mod_log_forensic.so
+%%LOGIO%%libexec/apache24/mod_logio.so
+%%LUA%%libexec/apache24/mod_lua.so
+%%MACRO%%libexec/apache24/mod_macro.so
+%%MIME%%libexec/apache24/mod_mime.so
+%%MIME_MAGIC%%libexec/apache24/mod_mime_magic.so
 %%MPM_SHARED%%libexec/apache24/mod_mpm_event.so
 %%MPM_SHARED%%libexec/apache24/mod_mpm_prefork.so
 %%MPM_SHARED%%libexec/apache24/mod_mpm_worker.so
-%%MOD_NEGOTIATION%%libexec/apache24/mod_negotiation.so
-%%MOD_OPTIONAL_FN_EXPORT%%libexec/apache24/mod_optional_fn_export.so
-%%MOD_OPTIONAL_FN_IMPORT%%libexec/apache24/mod_optional_fn_import.so
-%%MOD_OPTIONAL_HOOK_EXPORT%%libexec/apache24/mod_optional_hook_export.so
-%%MOD_OPTIONAL_HOOK_IMPORT%%libexec/apache24/mod_optional_hook_import.so
-%%MOD_PROXY%%libexec/apache24/mod_proxy.so
-%%MOD_PROXY_AJP%%libexec/apache24/mod_proxy_ajp.so
-%%MOD_PROXY_BALANCER%%libexec/apache24/mod_proxy_balancer.so
-%%MOD_PROXY_CONNECT%%libexec/apache24/mod_proxy_connect.so
-%%MOD_PROXY_EXPRESS%%libexec/apache24/mod_proxy_express.so
-%%MOD_PROXY_FCGI%%libexec/apache24/mod_proxy_fcgi.so
-%%MOD_PROXY_FDPASS%%libexec/apache24/mod_proxy_fdpass.so
-%%MOD_PROXY_FTP%%libexec/apache24/mod_proxy_ftp.so
-%%MOD_PROXY_HTML%%libexec/apache24/mod_proxy_html.so
-%%MOD_PROXY_HCHECK%%libexec/apache24/mod_proxy_hcheck.so
-%%MOD_PROXY_HTTP%%libexec/apache24/mod_proxy_http.so
-%%MOD_PROXY_HTTP2%%libexec/apache24/mod_proxy_http2.so
-%%MOD_PROXY_SCGI%%libexec/apache24/mod_proxy_scgi.so
-%%MOD_PROXY_WSTUNNEL%%libexec/apache24/mod_proxy_wstunnel.so
-%%MOD_RATELIMIT%%libexec/apache24/mod_ratelimit.so
-%%MOD_REFLECTOR%%libexec/apache24/mod_reflector.so
-%%MOD_REMOTEIP%%libexec/apache24/mod_remoteip.so
-%%MOD_REQTIMEOUT%%libexec/apache24/mod_reqtimeout.so
-%%MOD_REQUEST%%libexec/apache24/mod_request.so
-%%MOD_REWRITE%%libexec/apache24/mod_rewrite.so
-%%MOD_SED%%libexec/apache24/mod_sed.so
-%%MOD_SESSION%%libexec/apache24/mod_session.so
-%%MOD_SESSION_COOKIE%%libexec/apache24/mod_session_cookie.so
-%%MOD_SESSION_CRYPTO%%libexec/apache24/mod_session_crypto.so
-%%MOD_SESSION_DBD%%libexec/apache24/mod_session_dbd.so
-%%MOD_SETENVIF%%libexec/apache24/mod_setenvif.so
-%%MOD_SLOTMEM_PLAIN%%libexec/apache24/mod_slotmem_plain.so
-%%MOD_SLOTMEM_SHM%%libexec/apache24/mod_slotmem_shm.so
-%%MOD_SOCACHE_DBM%%libexec/apache24/mod_socache_dbm.so
-%%MOD_SOCACHE_DC%%libexec/apache24/mod_socache_dc.so
-%%MOD_SOCACHE_MEMCACHE%%libexec/apache24/mod_socache_memcache.so
-%%MOD_SOCACHE_SHMCB%%libexec/apache24/mod_socache_shmcb.so
-%%MOD_SPELING%%libexec/apache24/mod_speling.so
-%%MOD_SSL%%libexec/apache24/mod_ssl.so
-%%MOD_STATUS%%libexec/apache24/mod_status.so
-%%MOD_SUBSTITUTE%%libexec/apache24/mod_substitute.so
-%%MOD_SUEXEC%%libexec/apache24/mod_suexec.so
-%%MOD_UNIQUE_ID%%libexec/apache24/mod_unique_id.so
+%%NEGOTIATION%%libexec/apache24/mod_negotiation.so
+%%OPTIONAL_FN_EXPORT%%libexec/apache24/mod_optional_fn_export.so
+%%OPTIONAL_FN_IMPORT%%libexec/apache24/mod_optional_fn_import.so
+%%OPTIONAL_HOOK_EXPORT%%libexec/apache24/mod_optional_hook_export.so
+%%OPTIONAL_HOOK_IMPORT%%libexec/apache24/mod_optional_hook_import.so
+%%PROXY%%libexec/apache24/mod_proxy.so
+%%PROXY_AJP%%libexec/apache24/mod_proxy_ajp.so
+%%PROXY_BALANCER%%libexec/apache24/mod_proxy_balancer.so
+%%PROXY_CONNECT%%libexec/apache24/mod_proxy_connect.so
+%%PROXY_EXPRESS%%libexec/apache24/mod_proxy_express.so
+%%PROXY_FCGI%%libexec/apache24/mod_proxy_fcgi.so
+%%PROXY_FDPASS%%libexec/apache24/mod_proxy_fdpass.so
+%%PROXY_FTP%%libexec/apache24/mod_proxy_ftp.so
+%%PROXY_HTML%%libexec/apache24/mod_proxy_html.so
+%%PROXY_HCHECK%%libexec/apache24/mod_proxy_hcheck.so
+%%PROXY_HTTP%%libexec/apache24/mod_proxy_http.so
+%%PROXY_HTTP2%%libexec/apache24/mod_proxy_http2.so
+%%PROXY_SCGI%%libexec/apache24/mod_proxy_scgi.so
+%%PROXY_WSTUNNEL%%libexec/apache24/mod_proxy_wstunnel.so
+%%RATELIMIT%%libexec/apache24/mod_ratelimit.so
+%%REFLECTOR%%libexec/apache24/mod_reflector.so
+%%REMOTEIP%%libexec/apache24/mod_remoteip.so
+%%REQTIMEOUT%%libexec/apache24/mod_reqtimeout.so
+%%REQUEST%%libexec/apache24/mod_request.so
+%%REWRITE%%libexec/apache24/mod_rewrite.so
+%%SED%%libexec/apache24/mod_sed.so
+%%SESSION%%libexec/apache24/mod_session.so
+%%SESSION_COOKIE%%libexec/apache24/mod_session_cookie.so
+%%SESSION_CRYPTO%%libexec/apache24/mod_session_crypto.so
+%%SESSION_DBD%%libexec/apache24/mod_session_dbd.so
+%%SETENVIF%%libexec/apache24/mod_setenvif.so
+%%SLOTMEM_PLAIN%%libexec/apache24/mod_slotmem_plain.so
+%%SLOTMEM_SHM%%libexec/apache24/mod_slotmem_shm.so
+%%SOCACHE_DBM%%libexec/apache24/mod_socache_dbm.so
+%%SOCACHE_DC%%libexec/apache24/mod_socache_dc.so
+%%SOCACHE_MEMCACHE%%libexec/apache24/mod_socache_memcache.so
+%%SOCACHE_SHMCB%%libexec/apache24/mod_socache_shmcb.so
+%%SPELING%%libexec/apache24/mod_speling.so
+%%SSL%%libexec/apache24/mod_ssl.so
+%%STATUS%%libexec/apache24/mod_status.so
+%%SUBSTITUTE%%libexec/apache24/mod_substitute.so
+%%SUEXEC%%libexec/apache24/mod_suexec.so
+%%UNIQUE_ID%%libexec/apache24/mod_unique_id.so
 libexec/apache24/mod_unixd.so
-%%MOD_USERDIR%%libexec/apache24/mod_userdir.so
-%%MOD_USERTRACK%%libexec/apache24/mod_usertrack.so
-%%MOD_VERSION%%libexec/apache24/mod_version.so
-%%MOD_VHOST_ALIAS%%libexec/apache24/mod_vhost_alias.so
-%%MOD_WATCHDOG%%libexec/apache24/mod_watchdog.so
-%%MOD_XML2ENC%%libexec/apache24/mod_xml2enc.so
+%%USERDIR%%libexec/apache24/mod_userdir.so
+%%USERTRACK%%libexec/apache24/mod_usertrack.so
+%%VERSION%%libexec/apache24/mod_version.so
+%%VHOST_ALIAS%%libexec/apache24/mod_vhost_alias.so
+%%WATCHDOG%%libexec/apache24/mod_watchdog.so
+%%XML2ENC%%libexec/apache24/mod_xml2enc.so
 man/man1/ab.1.gz
 man/man1/apxs.1.gz
 man/man1/dbmmanage.1.gz